'============================================================================
'   apci34w.vb
'
'   Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'============================================================================
Option Strict Off
Option Explicit On 

Imports System
Imports System.Runtime.InteropServices

Public Class Apci34w

    Private mErrWradll As Integer = SUCCESS             ' bp[֐G[

    '-------------------------------------
    ' װޒ萔
    '-------------------------------------
    Public Const SUCCESS As Integer = 0                 ' ُȂ
    Public Const ERR_SYSTEM As Integer = 1              ' GetLastError sĂ
    Public Const ERR_NO_DEVICE As Integer = 2           ' gp\ȃfoCXȂ
    Public Const ERR_IN_USE As Integer = 3              ' w肳ꂽۯĂ͎gp
    Public Const ERR_INVALID_SLOT As Integer = 4        ' ȁi_jۯĔԍ
    Public Const ERR_RESOURCE As Integer = 5            ' \[XG[
    Public Const ERR_INVALID_PORT As Integer = 6        ' ȃ|[gԍ
    Public Const ERR_INVALID_ARGUMENT As Integer = 7    ' Ȉ
    Public Const ERR_NO_CREATE As Integer = 8           ' foCXNGCgĂ܂
    Public Const ERR_WRAPDLL As Integer = -1            ' bp[֐G[
    '-------------------------------------
    ' _߰
    '-------------------------------------
    Public Const PORT_1 As Integer = 0
    Public Const PORT_2 As Integer = 1
    Public Const PORT_3 As Integer = 2
    Public Const PORT_4 As Integer = 3
    '-------------------------------------
    ' IN01/IN02/IN09/IN10̊荞ݒ萔
    '-------------------------------------
    Public Const IRQ_ACTIVE_LOW As Integer = 0          ' Active Low
    Public Const IRQ_ACTIVE_HIGH As Integer = 1         ' Active High
    Public Const IRQ_DISABLE As Integer = 2             ' 荞݋֎~
    '-------------------------------------
    ' bZ[W
    ' Apci34Create  uWMBase ɐݒ肵lɂāAWM_IN01 Ȃǂ
    ' ItZbglbZ[Wo܂B
    '-------------------------------------
    Public Const WM_IN01 As Integer = 0                 ' IRQ0(IN01)
    Public Const WM_IN02 As Integer = 1                 ' IRQ1(IN02)
    Public Const WM_IN09 As Integer = 2                 ' IRQ2(IN09)
    Public Const WM_IN10 As Integer = 3                 ' IRQ3(IN10)
    Public Const WM_TMR As Integer = 4                  ' Timer
    '-------------------------------------
    ' ̑萔
    '-------------------------------------
    Public Const MAX_SLOTS As Integer = 16              ' T|[g{[h
    Public Const MAX_PORTS As Integer = 4               ' ANZX\ȃ|[g
    Public Const SLOT_AUTO As Short = -1
    '-------------------------------------
    ' ؿ\
    '-------------------------------------
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1
    Public Const MAX_IO As Integer = 20 - 1
    Public Const MAX_IRQ As Integer = 7 - 1
    Public Const MAX_DMA As Integer = 7 - 1
    Public Const MAX_RSV As Integer = 3 - 1

    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure
    '-------------------------------------
    ' 荞݃f[^\
    '-------------------------------------
    Structure Mode
        Dim dwIn01 As Integer ' IN01̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
        Dim dwIn02 As Integer ' IN02̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
        Dim dwIn09 As Integer ' IN09̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
        Dim dwIn10 As Integer ' IN10̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
    End Structure
    '-------------------------------------
    ' J֐
    '-------------------------------------
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDriverVersion As Integer) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34Create(ByRef pwLogSlot As Short, ByVal hWnd As Integer, ByVal uWMBase As Integer, ByRef pvInitArg As Integer) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34Close(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34GetResource(ByVal wLogSlot As Short, ByRef pres As Resource) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34InPort(ByVal wLogSlot As Short, ByVal dwLogPort As Integer, ByRef pbInValue As Byte) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34OutPort(ByVal wLogSlot As Short, ByVal dwLogPort As Integer, ByVal bOutValue As Byte) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34IrqMode(ByVal wLogSlot As Short, ByRef pcmode As Mode) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34EnableTimer(ByVal wLogSlot As Short, ByVal dwTimerCount As Integer, ByVal dwPlescaler As Integer) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34DisableTimer(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci34.dll")> _
    Public Shared Function Apci34GetLastError(ByVal wLogSlot As Short) As Integer
    End Function

    '============================================================================
    '     aPCI-P34 DLL,޲ײްްޮݔԍ擾
    '     pdwDllVersion    DLLްޮݔԍi[
    '         pdwDriverVersion ޲ײްްޮݔԍi[
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDriverVersion As Integer) As Boolean
        Try
            GetVersion = Apci34GetVersion(pdwDllVersion, pdwDriverVersion)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try
    End Function

    '============================================================================
    '     aPCI-P34̔Cӂ޲̎gp錾
    '     pwLogSlot  gp޲̘_ۯĔԍi[
    '         hWnd       bZ[W𑗂EBhEnh
    '         uWMBase    ƂȂ郁bZ[WID
    '         pvInitArg  gp(0Zbg)
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function Create(ByRef pwLogSlot As Short, ByVal hWnd As Integer, ByVal uWMBase As Integer, ByRef pvInitArg As Integer) As Boolean
        Try
            Create = Apci34Create(pwLogSlot, hWnd, uWMBase, pvInitArg)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try
    End Function

    '============================================================================
    '     aPCI-P34̔Cӂ޲̎gpJ
    '     wLogSlot ޲̘_ۯĔԍ
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function Close(ByVal wLogSlot As Short) As Boolean
        Try
            Close = Apci34Close(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try
    End Function

    '============================================================================
    '     w޲ؿ擾
    '     wLogSlot ؿ擾޲̘_ۯĔԍ
    '         pResInfo ؿi[\
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function GetResource(ByVal wLogSlot As Short, ByRef pres As Resource) As Boolean
        Try
            GetResource = Apci34GetResource(wLogSlot, pres)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try
    End Function

    '============================================================================
    '     ۰ذ̒l擾
    '     wLogSlot       ۰ذ̒l擾޲̘_ۯĔԍ
    '         pdwSwitchValue ۰ذ̒li[
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
        Try
            GetSwitchValue = Apci34GetSwitchValue(wLogSlot, pdwSwitchValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSwitchValue = False
        End Try
    End Function

    '============================================================================
    '     Cӂ߰Ăް
    '     wLogSlot  ͂޲̘_ۯĔԍ
    '         dwLogPort ͂_߰
    '         pbInValue ްi[
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function InPort(ByVal wLogSlot As Short, ByVal dwLogPort As Integer, ByRef pbInValue As Byte) As Boolean
        Try
            InPort = Apci34InPort(wLogSlot, dwLogPort, pbInValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            InPort = False
        End Try
    End Function

    '============================================================================
    '     Cӂ߰Ăްo
    '     wLogSlot  o͂޲̘_ۯĔԍ
    '         dwLogPort o͂_߰
    '         bOutValue o͂ް
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function OutPort(ByVal wLogSlot As Short, ByVal dwLogPort As Integer, ByVal bOutValue As Byte) As Boolean
        Try
            OutPort = Apci34OutPort(wLogSlot, dwLogPort, bOutValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            OutPort = False
        End Try
    End Function

    '============================================================================
    '     N01/IN02/IN09/IN10 ̊荞ݐݒ
    '     wLogSlot  o͂޲̘_ۯĔԍ
    '         pcmode    荞݃f[^̃AhX
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function IrqMode(ByVal wLogSlot As Short, ByRef pcmode As Mode) As Boolean
        Try
            IrqMode = Apci34IrqMode(wLogSlot, pcmode)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            IrqMode = False
        End Try
    End Function

    '============================================================================
    '     ^C}[荞݂Lɂ
    '     wLogSlot      o͂޲̘_ۯĔԍ
    '         dwTimerCount  ^C}[̃JE^
    '         dwPlescaler   ^C}[̃NbNg
    '  ߂l  True
    '              s False
    '============================================================================
    Public Function EnableTimer(ByVal wLogSlot As Short, ByVal dwTimerCount As Integer, ByVal dwPlescaler As Integer) As Boolean
        Try
            EnableTimer = Apci34EnableTimer(wLogSlot, dwTimerCount, dwPlescaler)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            EnableTimer = False
        End Try
    End Function

    '============================================================================
    '     ^C}[荞݂𖳌ɂ
    '     wLogSlot      o͂޲̘_ۯĔԍ
    '  ߂l  True
    '              s False
    '============================================================================
    Public Function DisableTimer(ByVal wLogSlot As Short) As Boolean
        Try
            DisableTimer = Apci34DisableTimer(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            DisableTimer = False
        End Try
    End Function

    '============================================================================
    '     aPCI-P34̴װ
    '     wLogSlot  װ޲̘_ۯĔԍ
    '  ߂l װ
    '============================================================================
    Public Function GetLastError(ByVal wLogSlot As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Apci34GetLastError(wLogSlot)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P34 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function

End Class
