Attribute VB_Name = "Wrapper"
'============================================================================
'   apci34w.bas
'
'   Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'   Date 2004/03/11
'
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI34_DLL_NAME = "apci34.dll"     ' DLL
Global Const APCI34_ERR_WRAPDLL = -1            ' ׯ߰֐װ

Dim hDLL As Long                'DLLւ

'============================================================================
'     apci34.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Apci34wDllOpen() As Boolean
    Apci34wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    
    hDLL = LoadLibrary(APCI34_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Apci34wGetDllExportFunc() = False Then
        Apci34wDllClose             ' DLL֐擾ɎŝDLL۰
        Exit Function
    End If
    
    Apci34wDllOpen = True

End Function
'============================================================================
'     apci34.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Apci34wDllClose() As Boolean
    
    Apci34wDllClose = True
    
    If hDLL = 0 Then Exit Function
    
    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Apci34wDllClose = False

End Function
'============================================================================
'     aPCI-P34 DLL,޲ײްްޮݔԍ擾
'     pdwDllVersion    DLLްޮݔԍi[
'         pdwDriverVersion ޲ײްްޮݔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Apci34wGetVersion(pdwDllVersion As Long, pdwDriverVersion As Long) As Boolean
    
    Apci34wGetVersion = False
    
    If hDLL = 0 Then Exit Function
    
    If Apci34GetVersion(pdwDllVersion, pdwDriverVersion) = 0 Then Exit Function
    
    Apci34wGetVersion = True

End Function
'============================================================================
'     aPCI-P34̔Cӂ޲̎gp錾
'     pwLogSlot  gp޲̘_ۯĔԍi[
'         hWnd       bZ[W𑗂EBhEnh
'         uWMBase    ƂȂ郁bZ[WID
'         pvInitArg  gp(0Zbg)
'  ߂l  True
'         s False
'============================================================================
Function Apci34wCreate(ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Boolean
    
    Apci34wCreate = False
    
    If hDLL = 0 Then Exit Function
    
    If Apci34Create(pwLogSlot, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function
    
    Apci34wCreate = True

End Function
'============================================================================
'     aPCI-P34̔Cӂ޲̎gpJ
'     wLogSlot ޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Apci34wClose(ByVal wLogSlot As Integer) As Boolean
    
    Apci34wClose = False
    
    If hDLL = 0 Then Exit Function
    
    If Apci34Close(wLogSlot) = 0 Then Exit Function
    
    Apci34wClose = True

End Function
'============================================================================
'     w޲ؿ擾
'     wLogSlot ؿ擾޲̘_ۯĔԍ
'         pResInfo ؿi[\
'  ߂l  True
'         s False
'============================================================================
Function Apci34wGetResource(ByVal wLogSlot As Integer, pResInfo As APCI34RESOURCE) As Boolean
    
    Apci34wGetResource = False
    
    If hDLL = 0 Then Exit Function
    
    If Apci34GetResource(wLogSlot, pResInfo) = 0 Then Exit Function
    
    Apci34wGetResource = True

End Function
'============================================================================
'     ۰ذ̒l擾
'     wLogSlot       ۰ذ̒l擾޲̘_ۯĔԍ
'         pdwSwitchValue ۰ذ̒li[
'  ߂l  True
'         s False
'============================================================================
Function Apci34wGetSwitchValue(ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Boolean
    
    Apci34wGetSwitchValue = False
    
    If hDLL = 0 Then Exit Function
    
    If Apci34GetSwitchValue(wLogSlot, pdwSwitchValue) = 0 Then Exit Function
    
    Apci34wGetSwitchValue = True

End Function
'============================================================================
'     Cӂ߰Ăް
'     wLogSlot  ͂޲̘_ۯĔԍ
'         dwLogPort ͂_߰
'         pbInValue ްi[
'  ߂l  True
'         s False
'============================================================================
Function Apci34wInPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, pbInValue As Byte) As Boolean
    
    Apci34wInPort = False
    
    If hDLL = 0 Then Exit Function
    
    If Apci34InPort(wLogSlot, dwLogPort, pbInValue) = 0 Then Exit Function
    
    Apci34wInPort = True

End Function
'============================================================================
'     Cӂ߰Ăްo
'     wLogSlot  o͂޲̘_ۯĔԍ
'         dwLogPort o͂_߰
'         bOutValue o͂ް
'  ߂l  True
'         s False
'============================================================================
Function Apci34wOutPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Boolean
    
    Apci34wOutPort = False
    
    If hDLL = 0 Then Exit Function
    
    If Apci34OutPort(wLogSlot, dwLogPort, bOutValue) = 0 Then Exit Function
    
    Apci34wOutPort = True

End Function
'============================================================================
'     N01/IN02/IN09/IN10 ̊荞ݐݒ
'     wLogSlot  o͂޲̘_ۯĔԍ
'         pcmode    荞݃f[^̃AhX
'  ߂l  True
'         s False
'============================================================================
Function Apci34wIrqMode(ByVal wLogSlot As Integer, ByRef pcmode As APCI34MODE) As Boolean

  Apci34wIrqMode = False

  If hDLL = 0 Then Exit Function

  If Apci34IrqMode(wLogSlot, pcmode) = 0 Then Exit Function
       
  Apci34wIrqMode = True

End Function
'============================================================================
'     ^C}[荞݂Lɂ
'     wLogSlot      o͂޲̘_ۯĔԍ
'         dwTimerCount  ^C}[̃JE^
'         dwPlescaler   ^C}[̃NbNg
'  ߂l  True
'              s False
'============================================================================
Function Apci34wEnableTimer(ByVal wLogSlot As Integer, ByVal dwTimerCount As Long, ByVal dwPlescaler As Long) As Boolean
    
    Apci34wEnableTimer = False

    If hDLL = 0 Then Exit Function

    If Apci34EnableTimer(wLogSlot, dwTimerCount, dwPlescaler) = 0 Then Exit Function
    
    Apci34wEnableTimer = True

End Function
'============================================================================
'     ^C}[荞݂𖳌ɂ
'     wLogSlot      o͂޲̘_ۯĔԍ
'  ߂l  True
'              s False
'============================================================================
Function Apci34wDisableTimer(ByVal wLogSlot As Integer) As Boolean
    
    Apci34wDisableTimer = False

    If hDLL = 0 Then Exit Function

    If Apci34DisableTimer(wLogSlot) = 0 Then Exit Function
    
    Apci34wDisableTimer = True

End Function
'============================================================================
'     aPCI-P34̴װ
'     wLogSlot  װ޲̘_ۯĔԍ
'  ߂l װ
'============================================================================
Function Apci34wGetLastError(ByVal wLogSlot As Integer) As Long
    
    Apci34wGetLastError = APCI34_ERR_WRAPDLL
  
    If hDLL = 0 Then Exit Function
  
    Apci34wGetLastError = Apci34GetLastError(wLogSlot)

End Function
'---------------------------------------------------------------------------
'     DLL߰Ċ֐ڽ̎擾
'     
'  ߂l  True
'         s False
'---------------------------------------------------------------------------
Private Function Apci34wGetDllExportFunc() As Boolean
    Dim pFunc As Long
  
    Apci34wGetDllExportFunc = False
  
    ' Apci34GetVersion ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34GetVersion")
    If pFunc = 0 Then Exit Function
  
    ' Apci34Create ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34Create")
    If pFunc = 0 Then Exit Function
  
    ' Apci34Close ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34Close")
    If pFunc = 0 Then Exit Function
  
    ' Apci34GetResource ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34GetResource")
    If pFunc = 0 Then Exit Function
  
    ' Apci34GetSwitchValue ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34GetSwitchValue")
    If pFunc = 0 Then Exit Function
  
    ' Apci34InPort ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34InPort")
    If pFunc = 0 Then Exit Function
  
    ' Apci34OutPort ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34OutPort")
    If pFunc = 0 Then Exit Function
  
    ' Apci34IrqMode ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34IrqMode")
    If pFunc = 0 Then Exit Function
  
    ' Apci34EnableTimer ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34EnableTimer")
    If pFunc = 0 Then Exit Function
  
    ' Apci34DisableTimer ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34DisableTimer")
    If pFunc = 0 Then Exit Function
  
    ' Apci34GetLastError ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci34GetLastError")
    If pFunc = 0 Then Exit Function
  
    Apci34wGetDllExportFunc = True   ' SĂ DLL ߰Ċ֐ڽ擾

End Function


