/*============================================================================
//	apci34s.cs
//
//	aPCI-P34
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/

/*============================================================================
// rh IvV̐ݒ菇܂B
//
// 1.vWFNg [vpeB] y[WJ܂B
// 2.[rh] vpeB y[WNbN܂B
// 3.[AZ[t R[h̋] `FbN {bNXIɂ܂B
//==========================================================================*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SampleP34
{
    public partial class Apci34s : Form
    {
        static Apci34w P34w;

        public Apci34s()
        {
            InitializeComponent();
        }

        private unsafe void Apci34s_Load(object sender, EventArgs e)
        {
            short wLogSlot;			// ޲̘_ۯĔԍi[
            Apci34w.Resource Ri;	// ؿ
            Apci34w.Mode Md;
            int dwDllVer, dwDrvVer;
            int dwSwVal;			// ۰ذ̒l
            int i;
            byte cbDat;
            bool bResult;			// 
            String szBuf;

            // 
            P34w = new Apci34w();
            Md   = new Apci34w.Mode();
            Ri   = new Apci34w.Resource();
            Ri.dwMemBase        = new int[Apci34w.MAX_MEM];
            Ri.dwMemLength      = new int[Apci34w.MAX_MEM];
            Ri.dwMemAttrib      = new int[Apci34w.MAX_MEM];
            Ri.dwIOPortBase     = new int[Apci34w.MAX_IO];
            Ri.dwIOPortLength   = new int[Apci34w.MAX_IO];
            Ri.dwIRQRegisters   = new int[Apci34w.MAX_IRQ];
            Ri.dwIRQAttrib      = new int[Apci34w.MAX_IRQ];
            Ri.dwDMALst         = new int[Apci34w.MAX_DMA];
            Ri.dwDMAAttrib      = new int[Apci34w.MAX_DMA];
            Ri.dwReserved1      = new int[Apci34w.MAX_RSV];
            Ri.dwNumMemWindows = 0;
            for (i = 0; i < Apci34w.MAX_MEM; i++)
            {
                Ri.dwMemBase[i] = 0;
                Ri.dwMemLength[i] = 0;
                Ri.dwMemAttrib[i] = 0;
            }
            Ri.dwNumIOPorts = 0;
            for (i = 0; i < Apci34w.MAX_IO; i++)
            {
                Ri.dwIOPortBase[i] = 0;
                Ri.dwIOPortLength[i] = 0;
            }
            Ri.dwNumIRQs = 0;
            for (i = 0; i < Apci34w.MAX_IRQ; i++)
            {
                Ri.dwIRQRegisters[i] = 0;
                Ri.dwIRQAttrib[i] = 0;
            }
            Ri.dwNumDMAs = 0;
            for (i = 0; i < Apci34w.MAX_DMA; i++)
            {
                Ri.dwDMALst[i] = 0;
                Ri.dwDMAAttrib[i] = 0;
            }
            for (i = 0; i < Apci34w.MAX_RSV; i++)
                Ri.dwReserved1[i] = 0;

            /*-----------------------------------------------------------------------*/
            // ްޮݔԍ\
            // aPCI-34 DLL,ײްްޮݔԍ擾
            if (P34w.GetVersion(&dwDllVer, &dwDrvVer) == false)
            {
                ErrorMessage(Apci34w.SLOT_AUTO);
                return;
            }
            szBuf = String.Concat("GetVersion",
                                    String.Format("\nDLL Version\t: {0:x8}", dwDllVer),
                                    String.Format("\nDRV Version\t: {0:x8}", dwDrvVer));
            ResultMessage(szBuf);

            /*-----------------------------------------------------------------------*/
            // aPCI-34̎gp錾
            wLogSlot = Apci34w.SLOT_AUTO;		// gp޲T܂
            bResult = P34w.Create(&wLogSlot, 0, 0, null);	// ꍇA̎޲̘_ۯĔԍi[܂
            if (bResult == false)				// ޲܂B
            {
                ErrorMessage(Apci34w.SLOT_AUTO);
                return;
            }
            szBuf = String.Concat("Created\n\n",
                                    String.Format("LogSlot: {0:d}", wLogSlot));
            ResultMessage(szBuf);

            /*-----------------------------------------------------------------------*/
            // ؿ۰ذ̒l擾
            if (P34w.GetResource(wLogSlot, ref Ri) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            if (P34w.GetSwitchValue(wLogSlot, &dwSwVal) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            szBuf = String.Concat(String.Format("\nIO Base Address  \t: {0:x4}h - {1:x4}h",
                                                    Ri.dwIOPortBase[1],
                                                    Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1),
                                    String.Format("\nIRQ         \t\t: {0:d}",
                                                    Ri.dwIRQRegisters[0]),
                                    String.Format("\nSwitch      \t: {0:x}h",
                                                    dwSwVal));
            ResultMessage(szBuf);

            /*-----------------------------------------------------------------------*/
            // IN01/IN02/IN09/IN10 ̊荞ݐݒ
            Md.dwIn01 = Apci34w.IRQ_DISABLE;			// 荞݋֎~
            Md.dwIn02 = Apci34w.IRQ_DISABLE;			// 荞݋֎~
            Md.dwIn09 = Apci34w.IRQ_DISABLE;			// 荞݋֎~
            Md.dwIn10 = Apci34w.IRQ_DISABLE;			// 荞݋֎~
            if (P34w.IrqMode(wLogSlot, ref Md) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }

            /*-----------------------------------------------------------------------*/
            // Port 1 ɔCӂްo
            cbDat = 0xaa;
            if (P34w.OutPort(wLogSlot, Apci34w.PORT_1, cbDat) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            szBuf = String.Concat("Port 1 փf[^o\n",
                                    String.Format("Port 1 Out Data: {0:x2}h", cbDat));
            ResultMessage(szBuf);

            /*-----------------------------------------------------------------------*/
            // Port 1 ްǂݍ
            cbDat = 0x00;
            if (P34w.InPort(wLogSlot, Apci34w.PORT_1, &cbDat) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            szBuf = String.Concat("Port 1 f[^\n",
                                    String.Format("Port 1 In Data: {0:x2}h", cbDat));
            ResultMessage(szBuf);

            /*-----------------------------------------------------------------------*/
            // IN01/IN02/IN09/IN10 ̊荞ݐݒ
            //Md.dwIn01 = Apci34w.IRQ_DISABLE;			// 荞݋֎~
            //Md.dwIn02 = Apci34w.IRQ_DISABLE;			// 荞݋֎~
            //Md.dwIn09 = Apci34w.IRQ_DISABLE;			// 荞݋֎~
            //Md.dwIn10 = Apci34w.IRQ_DISABLE;			// 荞݋֎~
            //if (P34w.IrqMode(wLogSlot, ref Md) == false)
            //{
            //    ErrorMessage(wLogSlot);
            //    return;
            //}

            /*-----------------------------------------------------------------------*/
            // aPCI-34̎gpJ
            if (P34w.Close(wLogSlot) == false)
            {
                ErrorMessage(wLogSlot);
                return;
            }
            ResultMessage("Closed");
            this.Close();
        }

        // ʂ\
        private void ResultMessage(string buf)
        {
            MessageBox.Show(buf, this.Text,
                            MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        // G[bZ[W\
        private void ErrorMessage(short wLogSlot)
        {
            int dwRes = P34w.GetLastError(wLogSlot);
            string buf;

            switch (dwRes)
            {
                case Apci34w.ERR_WRAPDLL:
                case Apci34w.ERR_SYSTEM:
                    dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error();
                    buf = String.Concat("System error\n\n",
                                        String.Format("Error code: {0:x8}h", dwRes));
                    break;

                default:
                    buf = String.Concat("aPCI-P34 error\n\n",
                                        String.Format("Error code: {0:x8}h", dwRes));
                    break;
            }
            MessageBox.Show(buf, this.Text,
                            MessageBoxButtons.OK, MessageBoxIcon.Stop);
        }

    }
}